/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_ENCA                                                     */
/* Tabela : ENCARGO                                                           */
/*                                                                            */
/* Criao:                                                                   */
/* 18/06/2001 - Newton Neves dos Santos                                       */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_ENCA
BEFORE INSERT OR UPDATE OR DELETE
ON ENCARGO FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUENCA := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDENCARGO,0) <> NVL(:NEW.CDENCARGO,0)) OR
         (NVL(:OLD.NMENCARGO,0) <> NVL(:NEW.NMENCARGO,0)) OR
         (NVL(:OLD.IDENCARGO,0) <> NVL(:NEW.IDENCARGO,0)) THEN
         :NEW.DTULTATUENCA := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('ENCARGO', '', 'CDENCARGO='||:OLD.CDENCARGO||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE ENCARGO MODIFY DTULTATUENCA DEFAULT SYSDATE
/
