/*
Criao:
30/11/2009 Camilo Csar
*/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_FILIALOPEROP' and
            type = 'TR'                      and
            u.uid = o.uid                    and
            u.name = USER)
  DROP TRIGGER DTULTATU_FILIALOPEROP
  GO

CREATE TRIGGER DTULTATU_FILIALOPEROP
ON FILIALOPEROP
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'FILIALOPEROP', CDFILIAL, 'CdFilial '+';'+CDFILIAL+';'+' CdGrupGerente '+''+CDGRUPGERENTEOP+';'+' CdOperador '+''+CDOPERADOR, GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE FILIALOPEROP
      SET DTULTATU = GETDATE()
      FROM INSERTED
      WHERE ISNULL(FILIALOPEROP.CDFILIAL,0) = ISNULL(INSERTED.CDFILIAL,0)
        AND ISNULL(FILIALOPEROP.CDGRUPGERENTEOP,0) = ISNULL(INSERTED.CDGRUPGERENTEOP,0)
        AND ISNULL(FILIALOPEROP.CDOPERADOR,0) = ISNULL(INSERTED.CDOPERADOR,0)
   END;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_FILIALOPEROP','5.09.000';
GO
