<?php
namespace Zeedhi\DevOps\Model\Projectmanagement\Repositories;


use Util\Utilities;

class CalendarWeeklyDays extends \Doctrine\ORM\EntityRepository
{


    public function getCalendarWeeklyDays($calendarId,$id, $organization,$withBase = true, $filter =' ')
    {
        $query = <<<SQL
        SELECT * FROM(
         SELECT TO_CHAR(CAD.END_DATE,'DD/MM/YYYY') AS END_DATE ,TO_CHAR(CAD.BEGIN_DATE,'DD/MM/YYYY') AS BEGIN_DATE,
         CAD.DAILY_HOURS AS WORKTIME,CAD.CALENDAR,CAD.ORGANIZATION,CAD.ID,CAD.NAME,CAD.NAME AS VALIDATION_NAME,
         CAD.ORIGIN_CALENDAR_DETAIL
         FROM CALENDAR_DETAIL CAD
         WHERE CAD.IS_EXCEPTION = 'N'
         AND ORGANIZATION = $organization
         AND CAD.CALENDAR = $calendarId
SQL;
        if($id){
            $query .= <<<SQL
        AND CAD.ID = $id
SQL;
        }
        if(!$withBase){
            $query .= <<<SQL
        AND CAD.END_DATE IS NOT NULL
SQL;
        }
        $query .= <<<SQL
         ORDER BY CAD.BEGIN_DATE,CAD.ID)
         WHERE 1= 1 $filter
SQL;
        $connection = $this->getEntityManager()->getConnection();
        $exceptions = $connection->fetchAll($query);
        foreach ($exceptions as &$exception) {
            $exception['WORKTIME'] = Utilities::secondsToTime($exception['WORKTIME']);

            $weeks = $this->getAllWeekDaysByCalendarDetailId($exception['ID']);
            foreach ($weeks as $week) {
                $exception['TYPE_'.Utilities::$ARRAY_WEEK_NAME_BY_BD[$week['WEEK_DAY']]] = $week['TYPE'];
                $weekHour = Utilities::secondsToTime($week['DAILY_HOURS']);
                $exception['DAILY_HOURS_'.Utilities::$ARRAY_WEEK_NAME_BY_BD[$week['WEEK_DAY']]] = $weekHour ? $weekHour : "0";
            }
        }
        return $exceptions;
    }

    public function getAllWeekDaysByCalendarDetailId($calendarDetailId)
    {
        $query = <<<SQL
        SELECT TYPE, WEEK_DAY,DAILY_HOURS FROM CALENDAR_WEEKLY_DAYS WHERE CALENDAR_DETAIL = $calendarDetailId
SQL;
        $connection = $this->getEntityManager()->getConnection();
        return $connection->fetchAll($query);
    }

}